# Blogwise Portfolio

[![pipeline status](https://gitlab.com/proguild-projects/python-web-workshop/blogwise-portfolio-prime/badges/main/pipeline.svg)](https://gitlab.com/proguild-projects/python-web-workshop/blogwise-portfolio-prime/-/commits/main) 

Live at: https://pguilddev.pythonanywhere.com

Blogwise is a simple, powerful, extensible platform for personal portfolios! It's also a fantastic project to add to any portfolio as a demonstration of knowledge and skill.
This version is a full-stack Python app, built using Flask. Since this serves as a demonstration of skill, this project is 90% Python and 10% external packages from Pypi. 

> This project is for training purposes only. Code used is to illucidate relevant concepts, unpack them and demonstrate them in a way that's transparent to students.

**App Features**

- Project Portfolio 
- Publishing (blog)
- Data API
- Landing pages

### Workshop Topics

Topics covered for this workshop:

1. HTTP server development with Flask
1. Client/UI design
1. RESTful APIs
1. Security practices
1. How to deploy your app
1. Presenting your digital portfolio


## Development Setup

This project is ready to run! 

You can develop in the editor of your choice. This project has a configuration for VS Code (Codium). If prompted, chose the interpreter that's defined as the default for this project (`.venv/bin/python`).

Running the program is as easy as pressing the F5 key. To get started:

- Clone this repo (if you haven't)
- `./set_env.sh`
- `pip install -r requirements.txt`
- Press F5 

If you have any trouble with your local setup, you can always run it the old fashioned way: `flask run`.

Happy coding!


## Additional Resources
Here are some tools you'll use throughout the workshop. 

**Official Docs**

These should ALWAYS be your first stop when you have questions about what you're building. _Chat bots and Google are a last resort when all else fails._

- [Python Docs](https://docs.python.org/3/)
- [Mozilla MDN](https://developer.mozilla.org/en-US/docs/Learn/HTML)
- [Flask Docs](https://flask.palletsprojects.com/en/3.0.x/)
- [Werkzeug Docs](https://werkzeug.palletsprojects.com/en/3.0.x/)

**Dev Guides**

When the docs aren't enough, these websites offer vast archives of explanations and examples, developed by experts at the top of their game.
- [CSS Tricks](https://css-tricks.com/)
- [Real Python](https://realpython.com/)

**Design Tools**

There's a tool for everything! For this workshop, these will suffice.
- [Draw.io](https://app.diagrams.net/?src=about) (for visual planning, diagrams)
- [ColorKit](https://colorkit.co/)
- [DaFont](https://www.dafont.com/)
- [QR Code Generator](https://www.qr-code-generator.com/) (for landing pages)
